package surveyor2;

import java.applet.AppletContext;
import java.awt.BorderLayout;
import java.awt.CardLayout;
import java.awt.Color;
import java.awt.ComponentOrientation;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.Font;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.GridLayout;
import java.awt.Insets;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.beans.PropertyChangeEvent;
import java.io.*;
import java.net.MalformedURLException;
import java.net.URL;
import java.net.URLConnection;
import java.net.URLEncoder;
import java.text.*;
import java.util.Date;
import java.util.Locale;
import java.util.Random;
import java.util.ResourceBundle;
import java.util.Vector;

import javax.swing.ButtonGroup;
import javax.swing.JApplet;
import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JRadioButton;
import javax.swing.JTextField;
import javax.swing.SwingConstants;
import javax.swing.UIManager;

/**
 * <b>Internationalized data collection program.</b>
 * 
 * @author David Heise.
 *         <P>
 * 
 */

public class Surveyor2 extends JApplet {
	
	// Next line gives Windows local-save directory as URL, for InternetSave=True.
	static final String DATA_DIRECTORY = "C:/Surveyor/Data/"; 

	static int NUMBER_OF_SCALES = 3; // Default number of ratings per stimulus.

	static final int MAX_SCALES = 25;

	static final int NUMBER_OF_ADJECTIVES = 5; // Available lines for scale anchors.

	static final String NO_DATA = "99";

	static final double ABORTED_DATA = -99.0;

	static final String INITIAL_RATINGS[] = new String[MAX_SCALES];

	static final long PAUSE_TIME = 0; // Keep at 0 milleseconds; see Heise SURVEYING CULTURES

	static final String TEXT_DELIMITER = "|";

	static final String COMMA_SPACE = ", ";

	static final String NEW_LINE = "\n";

	static final String QUOTE = "\"";

	static final int NUMBER_OF_TUTORIAL_LINES = 3;

	static final String successHTM = "";


	String projectIdentification, stimuliSetIdentification, nameOfArchive;

	String language, country;

	String PINstring, respondentInfo, successURLstring, emailAddress;

	int numberOfStimuliSets, forceStimulusSet, numberOfQuestions,
			questionIndex;

	int numberOfStimuli, currentStimulus, currentDimension, stimuliDone,
			startCountdownAt;

	int numberOfSkippedStimuli, numberOfEditedStimuli;

	long ratingsStartTime, ratingsStopTime, timeIncrement, ratingTime,
			tempTime;

	long baseTime = 996857593550L; // August 3, 2001

	DataLine[] dataSet;

	static final int APPLET_WIDTH = 640;

	static final int APPLET_HEIGHT = 480;

	int typesize, bigTypesize, littleTypesize;

	static public AppletContext context;

	static public URL documentBase, successURL;

	static public String baseDirectory, codeBase;

	static public Locale currentLocale;

	static ResourceBundle InterfaceTexts; // = ResourceBundle.getBundle("surveyor2.Messages");

	static ResourceBundle StimuliSet; // = ResourceBundle.getBundle("surveyor2.Words_"&number);

	static private final String MADE_BY_HEISE = " D. Heise, 2003, 2009.";

	Vector querySet;

	BackgroundQuestion currentQuestion;

	ActionEvent dummyEvent = new ActionEvent(this, 0, "");

	Random randomizer = new Random();
	
	NumberFormat numberFormater;
	
	int currentTutorialPage;
	
	long PIN;

	String positiveModifiers[][] = new String[MAX_SCALES][NUMBER_OF_ADJECTIVES];

	String negativeModifiers[][] = new String[MAX_SCALES][NUMBER_OF_ADJECTIVES];

	boolean concludingRatings = false;

	boolean usingSaveButton, tutorialIncluded, presentingTutorial,
			adverbsOnOneLine, reflectedScale, randomStimuliOrder;

	boolean anonymous, acquiringPersonalData, editingListOfDoneStimuli,
			debuggingSkip, internetSave;

	/**
	 * Interface elements.
	 */
	JPanel questionnaireCard = new JPanel();

	JPanel ratingCard = new JPanel();

	JPanel paymentCard = new JPanel();

	JPanel stopCard = new JPanel();

	JPanel optionCenteringPanel = new JPanel();

	JPanel questionOptionPanel = new JPanel();

	JPanel tutorialPanel = new JPanel();

	JPanel tutorialTextPanel = new JPanel();

	JPanel stimulusPanel = new JPanel();

	JPanel leftAdjectivePanel = new JPanel();

	JPanel rightAdjectivePanel = new JPanel();

	JPanel scalingPanel = new JPanel();

	JPanel adverbPanel = new JPanel();

	JPanel saveButtonPanel = new JPanel();

	JPanel progressPanel = new JPanel();

	JPanel messagePanel = new JPanel();

	JPanel formPanel = new JPanel();

	JPanel namePanel = new JPanel();

	JPanel address1Panel = new JPanel();

	JPanel address2Panel = new JPanel();

	JPanel cityPanel = new JPanel();

	JPanel submitButtonPanel = new JPanel();

	JLabel questionnaireInstruction = new JLabel();

	JLabel questionStub = new JLabel();

	JLabel Stimulus1 = new JLabel();

	JLabel Stimulus2 = new JLabel();

	JLabel tutorialLine[] = new JLabel[NUMBER_OF_TUTORIAL_LINES];

	JLabel leftAdjective0 = new JLabel();

	JLabel leftAdjective1 = new JLabel();

	JLabel leftAdjective2 = new JLabel();

	JLabel leftAdjective3 = new JLabel();

	JLabel leftAdjective4 = new JLabel();

	JLabel rightAdjective0 = new JLabel();

	JLabel rightAdjective1 = new JLabel();

	JLabel rightAdjective2 = new JLabel();

	JLabel rightAdjective3 = new JLabel();

	JLabel rightAdjective4 = new JLabel();

	JLabel infiniteR = new JLabel();

	JLabel extremeR = new JLabel();

	JLabel quiteR = new JLabel();

	JLabel slightR = new JLabel();

	JLabel neutral = new JLabel();

	JLabel slightL = new JLabel();

	JLabel quiteL = new JLabel();

	JLabel extremeL = new JLabel();

	JLabel infiniteL = new JLabel();

	JLabel progressLabel = new JLabel();

	JLabel formInstruction1 = new JLabel();

	JLabel formInstruction2 = new JLabel();

	JLabel formInstruction3 = new JLabel();

	JLabel yourNameLabel = new JLabel();

	JLabel address1Label = new JLabel();

	JLabel address2Label = new JLabel();

	JLabel cityLabel = new JLabel();

	JLabel stopTheSessionLabel = new JLabel();

	JLabel pinTextLabel = new JLabel();

	JButton questionnaireContinueButton = new JButton();

	JButton tutorialButton = new JButton();

	JButton saveButton = new JButton();

	JButton editButton = new JButton();

	JButton skipButton = new JButton();

	JButton submitButton = new JButton();

	ButtonGroup optionsGroup = new ButtonGroup();

	JRadioButton[] option = new JRadioButton[BackgroundQuestion.MAX_OPTIONS];

	MySlider slider1 = new MySlider();

	JComboBox reviseComboBox = new JComboBox();

	JTextField pinLabel = new JTextField();

	JTextField yourNameField = new JTextField();

	JTextField address1Field = new JTextField();

	JTextField address2Field = new JTextField();

	JTextField cityField = new JTextField();

	JOptionPane areYouSurePane = new JOptionPane();

	CardLayout appletCardLayout = new CardLayout();

	GridBagLayout questionnaireCardGridBagLayout = new GridBagLayout();

	GridBagLayout ratingCardGridBagLayout = new GridBagLayout();

	GridBagLayout scalingPanelGridBagLayout = new GridBagLayout();

	GridBagLayout adverbGridBagLayout = new GridBagLayout();

	GridLayout paymentCardGridLayout = new GridLayout();

	GridLayout stopCardGridLayout = new GridLayout();

	BVerticalFlowLayout plainVerticalFlowLayout = new BVerticalFlowLayout();

	BVerticalFlowLayout expaningVerticalFlowLayout = new BVerticalFlowLayout(true, true);

	FlowLayout tutorialFlowLayout = new FlowLayout();

	FlowLayout paymentFormFlowLayout = new FlowLayout();

	BorderLayout paymentCardBorderLayout = new BorderLayout();

	ComponentOrientation textDirection;

	/** Set look and feel. */
	static {
		try {
			UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
			// UIManager.setLookAndFeel(UIManager.getCrossPlatformLookAndFeelClassName());
		} catch (Exception e) {
		}
	}

	/** Get a parameter value */
	public String getParameter(String key, String defaultValue) {
		return getParameter(key) != null ? getParameter(key) : defaultValue;
	}

	/** Construct the applet */
	public Surveyor2() {
	}

	/** Initialize the applet */
	public void init() {

		// Read the applet parameters.
		try {
			numberOfStimuliSets = Integer.parseInt(this.getParameter(
					"NumberOfStimuliSets", "1"));
		} catch (Exception e) {
			e.printStackTrace();
		}
		try {
			startCountdownAt = Integer.parseInt(this.getParameter(
					"BeginCountdownAt", "10"));
		} catch (Exception e) {
			e.printStackTrace();
		}
		try {
			usingSaveButton = Boolean.valueOf(
					this.getParameter("UseSaveButton", "false")).booleanValue();
		} catch (Exception e) {
			e.printStackTrace();
		}
		try {
			tutorialIncluded = Boolean.valueOf(
					this.getParameter("GiveTutorial", "false")).booleanValue();
		} catch (Exception e) {
			e.printStackTrace();
		}
		try {
			forceStimulusSet = Integer.parseInt(this.getParameter(
					"ForceStimuliSet", "0"));
		} catch (Exception e) {
			e.printStackTrace();
		}
		if (forceStimulusSet < 0) { // Negative means fixed order for stimuli.
			forceStimulusSet = -forceStimulusSet;
			randomStimuliOrder = false;
		} else {
			// forceStimulusSet = parameter value
			randomStimuliOrder = true;
		}
		try {
			language = this.getParameter("Language", "en");
		} catch (Exception e) {
			e.printStackTrace();
		}
		try {
			country = this.getParameter("Country", "US");
		} catch (Exception e) {
			e.printStackTrace();
		}
		try {
			typesize = Integer.parseInt(this.getParameter("Typesize", "10"));
		} catch (Exception e) {
			e.printStackTrace();
		}
		bigTypesize = typesize + 2;
		littleTypesize = typesize - 2;
		try {
			adverbsOnOneLine = Boolean.valueOf(
					this.getParameter("LineOfAdverbs", "true")).booleanValue();
		} catch (Exception e) {
			e.printStackTrace();
		}
		try {
			NUMBER_OF_SCALES = Integer.parseInt(this.getParameter(
					"MeasuresPerStimulus", "3"));
		} catch (Exception e) {
			e.printStackTrace();
		}
		try {
			acquiringPersonalData = Boolean.valueOf(
					this.getParameter("AcquirePersonalInfo", "true"))
					.booleanValue();
		} catch (Exception e) {
			e.printStackTrace();
		}
		try {
			anonymous = Boolean.valueOf(this.getParameter("Anonymous", "true"))
					.booleanValue();
		} catch (Exception e) {
			e.printStackTrace();
		}
		try {
			successURLstring = this.getParameter("successURL", "");
		} catch (Exception e) {
			e.printStackTrace();
		}
		try {
			emailAddress = this.getParameter("emailAddress",
					"socpsy@indiana.edu");
		} catch (Exception e) {
			e.printStackTrace();
		}
		if (emailAddress.equalsIgnoreCase("")) {
			emailAddress = "socpsy@indiana.edu";
		}
		try {
			debuggingSkip = Boolean.valueOf(
					this.getParameter("DebuggingSkip", "false")).booleanValue();
		} catch (Exception e) {
			e.printStackTrace();
		}
		try {
			internetSave = Boolean.valueOf(
					this.getParameter("InternetSave", "true")).booleanValue();
		} catch (Exception e) {
			e.printStackTrace();
		}

		try { // Initialized and begin processes.
			jbInit();
		} catch (Exception e) {
			e.printStackTrace();
		}
	} // End init.

	/** Component initialization */
	private void jbInit() throws Exception {
		this.setSize(new Dimension(APPLET_WIDTH, APPLET_HEIGHT));
		/**
		 * Set up local formats.
		 */
		currentLocale = new Locale(language, country);
		InterfaceTexts = ResourceBundle.getBundle("surveyor2.Messages", currentLocale);
		textDirection = ComponentOrientation.getOrientation(currentLocale);
		numberFormater = NumberFormat.getInstance(currentLocale);
		DecimalFormat decimalFormater = (DecimalFormat) numberFormater;
		DecimalFormatSymbols dfs = decimalFormater.getDecimalFormatSymbols();
		String s = InterfaceTexts.getString("UnicodeZero");
		char c = s.charAt(0);
		dfs.setZeroDigit(c);
		decimalFormater.setDecimalFormatSymbols(dfs);
		/**
		 * Establish the cards in use.
		 */
		this.getContentPane().setBackground(Color.white);
		this.getContentPane().setLayout(appletCardLayout);
		this.getContentPane().add(questionnaireCard, "questionnaireCard");
		this.getContentPane().add(ratingCard, "ratingCard");
		this.getContentPane().add(paymentCard, "paymentCard");
		this.getContentPane().add(stopCard, "stopCard");
		/**
		 * Layout questionnaireCard
		 */
		questionnaireCard.setLayout(questionnaireCardGridBagLayout);
		questionnaireCard.setBackground(Color.white);
		questionnaireInstruction.setBackground(Color.white);
		questionnaireInstruction.setFont(new Font("Dialog", 1, bigTypesize));
		questionStub.setFont(new Font("Dialog", 1, typesize));
		optionCenteringPanel.setBackground(Color.white);
		questionOptionPanel.setBackground(Color.white);
		questionnaireCard.add(questionnaireInstruction, new GridBagConstraints(
				0, 0, 1, 1, 0.0, 2.0, GridBagConstraints.NORTH,
				GridBagConstraints.BOTH, new Insets(0, 0, 0, 0), 0, 0));
		questionnaireCard.add(questionStub, new GridBagConstraints(0, 1, 1, 1,
				0.0, 1.0, GridBagConstraints.SOUTH, GridBagConstraints.NONE,
				new Insets(0, 0, 0, 0), 0, 0));
		questionnaireCard.add(optionCenteringPanel, new GridBagConstraints(0,
				2, 1, 1, 1.0, 2.0, GridBagConstraints.CENTER,
				GridBagConstraints.BOTH, new Insets(0, 0, 0, 0), 1, 1));
		questionnaireInstruction.setHorizontalAlignment(SwingConstants.CENTER);
		questionnaireInstruction.setText("questionnaire instruction");
		optionCenteringPanel.add(questionOptionPanel, null);
		questionOptionPanel.setLayout(plainVerticalFlowLayout);
		for (int i = 0; i < BackgroundQuestion.MAX_OPTIONS; i++) {
			option[i] = new JRadioButton();
			option[i].setBackground(Color.white);
			option[i].setFont(new Font("Dialog", 1, typesize));
			optionsGroup.add(option[i]);
			option[i].setVisible(true);
			questionOptionPanel.add(option[i], null);
		}
		questionnaireContinueButton.setFont(new Font("Dialog", 1, bigTypesize));
		questionOptionPanel.add(questionnaireContinueButton, null);

		/**
		 * Layout ratingCard
		 */
		ratingCard.setBackground(Color.white);
		ratingCard.setLayout(ratingCardGridBagLayout);
		ratingCard.add(tutorialPanel, new GridBagConstraints(0, 0, 3, 1, 0.0,
				0.0, GridBagConstraints.SOUTH, GridBagConstraints.NONE,
				new Insets(0, 0, 0, 0), 0, 0));
		ratingCard.add(stimulusPanel, new GridBagConstraints(0, 1, 3, 1, 1.0,
				3.0, GridBagConstraints.SOUTH, GridBagConstraints.NONE,
				new Insets(0, 0, 0, 0), 0, 0));
		ratingCard.add(leftAdjectivePanel, new GridBagConstraints(0, 2, 1, 1,
				1.0, 2.0, GridBagConstraints.EAST, GridBagConstraints.NONE,
				new Insets(0, 0, 0, 0), 0, 0));
		ratingCard.add(rightAdjectivePanel, new GridBagConstraints(2, 2, 1, 1,
				1.0, 2.0, GridBagConstraints.WEST, GridBagConstraints.NONE,
				new Insets(0, 0, 0, 0), 0, 0));
		ratingCard.add(scalingPanel, new GridBagConstraints(1, 2, 1, 1, 0.0,
				0.0, GridBagConstraints.CENTER, GridBagConstraints.BOTH,
				new Insets(0, 0, 0, 0), 0, 0));
		ratingCard.add(saveButtonPanel, new GridBagConstraints(0, 3, 3, 1, 0.0,
				0.0, GridBagConstraints.CENTER, GridBagConstraints.BOTH,
				new Insets(40, 0, 0, 0), 0, 0));
		ratingCard.add(progressPanel, new GridBagConstraints(0, 4, 3, 1, 0.0,
				0.0, GridBagConstraints.CENTER, GridBagConstraints.NONE,
				new Insets(0, 0, 0, 0), 0, 0));
		ratingCard.add(reviseComboBox, new GridBagConstraints(0, 5, 3, 1, 0.0,
				0.0, GridBagConstraints.CENTER, GridBagConstraints.NONE,
				new Insets(0, 0, 0, 0), 0, 0));
		for (int i = 0; i < NUMBER_OF_TUTORIAL_LINES; i++) {
			tutorialLine[i] = new JLabel();
			tutorialLine[i].setBackground(Color.white);
			tutorialLine[i].setForeground(Color.blue);
			tutorialLine[i].setFont(new Font("Dialog", 1, typesize));
			tutorialTextPanel.add(tutorialLine[i], null);
		}

		tutorialPanel.setLayout(tutorialFlowLayout);
		tutorialPanel.setBackground(Color.white);
		tutorialTextPanel.setBackground(Color.white);
		tutorialTextPanel.setLayout(plainVerticalFlowLayout);
		tutorialButton.setText("tutorial button");
		tutorialButton.setFont(new Font("Dialog", 1, typesize));
		if (textDirection.isLeftToRight()) {
			tutorialPanel.add(tutorialTextPanel, null);
			tutorialPanel.add(tutorialButton, null);
		} else {
			tutorialPanel.add(tutorialButton, null);
			tutorialPanel.add(tutorialTextPanel, null);
			for (int i = 0; i < BackgroundQuestion.MAX_OPTIONS; i++) {
				option[i]
						.setComponentOrientation(ComponentOrientation.RIGHT_TO_LEFT);
			}
			reviseComboBox
					.setComponentOrientation(ComponentOrientation.RIGHT_TO_LEFT);
			((JLabel) reviseComboBox.getRenderer())
					.applyComponentOrientation(ComponentOrientation.RIGHT_TO_LEFT);
		}

		stimulusPanel.setLayout(plainVerticalFlowLayout);
		stimulusPanel.setBackground(Color.white);
		stimulusPanel.add(Stimulus1, null);
		stimulusPanel.add(Stimulus2, null);
		Stimulus1.setBackground(Color.white);
		Stimulus2.setBackground(Color.white);
		Stimulus1.setAlignmentY(JLabel.CENTER);
		Stimulus2.setAlignmentY(JLabel.CENTER);
		Stimulus1.setFont(new Font("Dialog", 1, bigTypesize));
		Stimulus2.setFont(new Font("Dialog", 1, bigTypesize));
		Stimulus1.setText("");
		Stimulus2.setText("");

		leftAdjectivePanel.setLayout(plainVerticalFlowLayout);
		leftAdjectivePanel.add(leftAdjective0, null);
		leftAdjectivePanel.add(leftAdjective1, null);
		leftAdjectivePanel.add(leftAdjective2, null);
		leftAdjectivePanel.add(leftAdjective3, null);
		leftAdjectivePanel.add(leftAdjective4, null);
		leftAdjectivePanel.setBackground(Color.white);
		leftAdjective0.setBackground(Color.white);
		leftAdjective1.setBackground(Color.white);
		leftAdjective2.setBackground(Color.white);
		leftAdjective3.setBackground(Color.white);
		leftAdjective4.setBackground(Color.white);
		leftAdjective0.setFont(new Font("Dialog", 1, typesize));
		leftAdjective1.setFont(new Font("Dialog", 1, typesize));
		leftAdjective2.setFont(new Font("Dialog", 1, typesize));
		leftAdjective3.setFont(new Font("Dialog", 1, typesize));
		leftAdjective4.setFont(new Font("Dialog", 1, typesize));
		leftAdjective0.setHorizontalAlignment(SwingConstants.RIGHT);
		leftAdjective1.setHorizontalAlignment(SwingConstants.RIGHT);
		leftAdjective2.setHorizontalAlignment(SwingConstants.RIGHT);
		leftAdjective3.setHorizontalAlignment(SwingConstants.RIGHT);
		leftAdjective4.setHorizontalAlignment(SwingConstants.RIGHT);
		leftAdjective0.setHorizontalTextPosition(SwingConstants.RIGHT);
		leftAdjective1.setHorizontalTextPosition(SwingConstants.RIGHT);
		leftAdjective2.setHorizontalTextPosition(SwingConstants.RIGHT);
		leftAdjective3.setHorizontalTextPosition(SwingConstants.RIGHT);
		leftAdjective4.setHorizontalTextPosition(SwingConstants.RIGHT);

		rightAdjectivePanel.setLayout(plainVerticalFlowLayout);
		rightAdjectivePanel.add(rightAdjective0, null);
		rightAdjectivePanel.add(rightAdjective1, null);
		rightAdjectivePanel.add(rightAdjective2, null);
		rightAdjectivePanel.add(rightAdjective3, null);
		rightAdjectivePanel.add(rightAdjective4, null);
		rightAdjectivePanel.setBackground(Color.white);
		rightAdjective0.setBackground(Color.white);
		rightAdjective1.setBackground(Color.white);
		rightAdjective2.setBackground(Color.white);
		rightAdjective3.setBackground(Color.white);
		rightAdjective4.setBackground(Color.white);
		rightAdjective0.setFont(new Font("Dialog", 1, typesize));
		rightAdjective1.setFont(new Font("Dialog", 1, typesize));
		rightAdjective2.setFont(new Font("Dialog", 1, typesize));
		rightAdjective3.setFont(new Font("Dialog", 1, typesize));
		rightAdjective4.setFont(new Font("Dialog", 1, typesize));
		rightAdjective0.setHorizontalAlignment(SwingConstants.LEFT);
		rightAdjective1.setHorizontalAlignment(SwingConstants.LEFT);
		rightAdjective2.setHorizontalAlignment(SwingConstants.LEFT);
		rightAdjective3.setHorizontalAlignment(SwingConstants.LEFT);
		rightAdjective4.setHorizontalAlignment(SwingConstants.LEFT);

		scalingPanel.setLayout(scalingPanelGridBagLayout);
		scalingPanel.setBackground(Color.white);

		slider1.setBackground(Color.white);
		slider1.setShowingDigitLabels(false);

		adverbPanel.setBackground(Color.white);
		infiniteR.setBackground(Color.white);
		extremeR.setBackground(Color.white);
		quiteR.setBackground(Color.white);
		slightR.setBackground(Color.white);
		neutral.setBackground(Color.white);
		slightL.setBackground(Color.white);
		quiteL.setBackground(Color.white);
		infiniteL.setBackground(Color.white);
		extremeL.setBackground(Color.white);
		infiniteR.setFont(new Font("Dialog", 1, littleTypesize));
		extremeR.setFont(new Font("Dialog", 1, littleTypesize));
		quiteR.setFont(new Font("Dialog", 1, littleTypesize));
		slightR.setFont(new Font("Dialog", 1, littleTypesize));
		neutral.setFont(new Font("Dialog", 1, littleTypesize));
		slightL.setFont(new Font("Dialog", 1, littleTypesize));
		quiteL.setFont(new Font("Dialog", 1, littleTypesize));
		extremeL.setFont(new Font("Dialog", 1, littleTypesize));
		infiniteL.setFont(new Font("Dialog", 1, littleTypesize));
		infiniteR.setHorizontalAlignment(SwingConstants.RIGHT);
		extremeR.setHorizontalAlignment(SwingConstants.CENTER);
		quiteR.setHorizontalAlignment(SwingConstants.CENTER);
		slightR.setHorizontalAlignment(SwingConstants.CENTER);
		neutral.setHorizontalAlignment(SwingConstants.CENTER);
		slightL.setHorizontalAlignment(SwingConstants.CENTER);
		quiteL.setHorizontalAlignment(SwingConstants.CENTER);
		infiniteL.setHorizontalAlignment(SwingConstants.CENTER);
		extremeL.setHorizontalAlignment(SwingConstants.CENTER);
		infiniteL.setHorizontalAlignment(SwingConstants.LEFT);

		adverbPanel.setLayout(adverbGridBagLayout);
		if (adverbsOnOneLine) {
			scalingPanel.add(slider1, new GridBagConstraints(0, 0, 1, 1, 1.0,
					1.0, GridBagConstraints.SOUTH,
					GridBagConstraints.HORIZONTAL, new Insets(0, 18, 0, 0), 0,
					0));
			scalingPanel.add(adverbPanel,
					new GridBagConstraints(0, 1, 1, 1, 1.0, 1.0,
							GridBagConstraints.NORTH,
							GridBagConstraints.HORIZONTAL, new Insets(0, 0, 0,
									0), 0, 0));
			int adverbCols[] = { 65, 50, 50, 50, 50, 50, 50, 50, 65 };
			adverbGridBagLayout.columnWidths = adverbCols;
			adverbPanel.add(infiniteL, new GridBagConstraints(0, 0, 1, 1, 1.0,
					0.0, GridBagConstraints.WEST, GridBagConstraints.NONE,
					new Insets(0, 0, 0, 0), 0, 0));
			adverbPanel.add(extremeL,
					new GridBagConstraints(1, 0, 1, 1, 1.0, 0.0,
							GridBagConstraints.CENTER,
							GridBagConstraints.HORIZONTAL, new Insets(0, 0, 0,
									0), 0, 0));
			adverbPanel.add(quiteL,
					new GridBagConstraints(2, 0, 1, 1, 1.0, 0.0,
							GridBagConstraints.CENTER,
							GridBagConstraints.HORIZONTAL, new Insets(0, 0, 0,
									0), 0, 0));
			adverbPanel.add(slightL,
					new GridBagConstraints(3, 0, 1, 1, 1.0, 0.0,
							GridBagConstraints.CENTER,
							GridBagConstraints.HORIZONTAL, new Insets(0, 0, 0,
									0), 0, 0));
			adverbPanel.add(neutral,
					new GridBagConstraints(4, 0, 1, 1, 1.0, 0.0,
							GridBagConstraints.CENTER,
							GridBagConstraints.HORIZONTAL, new Insets(0, 0, 0,
									0), 0, 0));
			adverbPanel.add(slightR,
					new GridBagConstraints(5, 0, 1, 1, 1.0, 0.0,
							GridBagConstraints.CENTER,
							GridBagConstraints.HORIZONTAL, new Insets(0, 0, 0,
									0), 0, 0));
			adverbPanel.add(quiteR,
					new GridBagConstraints(6, 0, 1, 1, 1.0, 0.0,
							GridBagConstraints.CENTER,
							GridBagConstraints.HORIZONTAL, new Insets(0, 0, 0,
									0), 0, 0));
			adverbPanel.add(extremeR,
					new GridBagConstraints(7, 0, 1, 1, 1.0, 0.0,
							GridBagConstraints.CENTER,
							GridBagConstraints.HORIZONTAL, new Insets(0, 0, 0,
									0), 0, 0));
			adverbPanel.add(infiniteR,
					new GridBagConstraints(8, 0, 1, 1, 1.0, 0.0,
							GridBagConstraints.EAST,
							GridBagConstraints.HORIZONTAL, new Insets(0, 0, 0,
									0), 0, 0));
		} else {
			scalingPanel.add(slider1,
					new GridBagConstraints(0, 0, 1, 1, 1.0, 1.0,
							GridBagConstraints.SOUTH,
							GridBagConstraints.HORIZONTAL, new Insets(0, 0, 0,
									0), 0, 0));
			scalingPanel.add(adverbPanel,
					new GridBagConstraints(0, 1, 1, 1, 1.0, 1.0,
							GridBagConstraints.NORTH,
							GridBagConstraints.HORIZONTAL, new Insets(0, 0, 0,
									0), 0, 0));
			int adverbCols[] = { 22, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25,
					25, 25, 25, 25, 25, 25, 22 };
			adverbGridBagLayout.columnWidths = adverbCols;
			adverbPanel.add(infiniteL, new GridBagConstraints(0, 0, 3, 1, 1.0,
					0.0, GridBagConstraints.WEST, GridBagConstraints.BOTH,
					new Insets(0, 0, 0, 0), 0, 0));
			adverbPanel.add(extremeL, new GridBagConstraints(1, 1, 4, 1, 1.0,
					0.0, GridBagConstraints.CENTER, GridBagConstraints.BOTH,
					new Insets(0, 0, 0, 0), 0, 0));
			adverbPanel.add(quiteL, new GridBagConstraints(3, 0, 4, 1, 1.0,
					0.0, GridBagConstraints.CENTER, GridBagConstraints.BOTH,
					new Insets(0, 0, 0, 0), 0, 0));
			adverbPanel.add(slightL, new GridBagConstraints(5, 1, 4, 1, 1.0,
					0.0, GridBagConstraints.CENTER, GridBagConstraints.BOTH,
					new Insets(0, 0, 0, 0), 0, 0));
			adverbPanel.add(neutral, new GridBagConstraints(7, 0, 4, 1, 1.0,
					0.0, GridBagConstraints.CENTER, GridBagConstraints.BOTH,
					new Insets(0, 0, 0, 0), 0, 0));
			adverbPanel.add(slightR, new GridBagConstraints(9, 1, 4, 1, 1.0,
					0.0, GridBagConstraints.CENTER, GridBagConstraints.BOTH,
					new Insets(0, 0, 0, 0), 0, 0));
			adverbPanel.add(quiteR, new GridBagConstraints(11, 0, 4, 1, 1.0,
					0.0, GridBagConstraints.CENTER, GridBagConstraints.BOTH,
					new Insets(0, 0, 0, 0), 0, 0));
			adverbPanel.add(extremeR, new GridBagConstraints(13, 1, 4, 1, 1.0,
					0.0, GridBagConstraints.CENTER, GridBagConstraints.BOTH,
					new Insets(0, 0, 0, 0), 0, 0));
			adverbPanel.add(infiniteR, new GridBagConstraints(16, 0, 3, 1, 1.0,
					0.0, GridBagConstraints.WEST, GridBagConstraints.BOTH,
					new Insets(0, 0, 0, 0), 0, 0));
		}

		saveButtonPanel.setBackground(Color.white);
		saveButtonPanel.add(saveButton, null);
		saveButton.setSelected(true);
		saveButton.setFont(new Font("Dialog", 1, typesize));
		if (usingSaveButton) {
			slider1.setSnappingToOrigin(false);
			saveButton.setVisible(true);
		} else {
			slider1.setSnappingToOrigin(true);
			saveButton.setVisible(false);
		}

		editButton.setFont(new Font("Dialog", 1, typesize));
		skipButton.setFont(new Font("Dialog", 1, typesize));
		progressLabel.setFont(new Font("Dialog", 1, typesize));
		progressPanel.add(editButton, null);
		progressPanel.add(progressLabel, null);
		progressPanel.add(skipButton, null);
		progressLabel.setBackground(Color.WHITE);
		progressLabel.setForeground(Color.GREEN);
		progressPanel.setBackground(Color.WHITE);

		reviseComboBox.setFont(new Font("Dialog", 0, littleTypesize));
		reviseComboBox.setMaximumRowCount(12);
		reviseComboBox.setVisible(false);

		/**
		 * Layout paymentCard
		 */
		paymentCard.setLayout(paymentCardBorderLayout);
		formPanel.setLayout(paymentCardGridLayout);
		namePanel.setLayout(paymentFormFlowLayout);
		paymentCardGridLayout.setRows(5);
		paymentCardGridLayout.setColumns(1);
		paymentCard.add(messagePanel, BorderLayout.NORTH);
		paymentCard.add(formPanel, BorderLayout.CENTER);
		paymentCard.add(submitButtonPanel, BorderLayout.SOUTH);
		paymentCard.setBackground(Color.white);
		formInstruction1.setBackground(Color.white);
		formInstruction2.setBackground(Color.white);
		messagePanel.setBackground(Color.white);
		submitButtonPanel.setBackground(Color.white);
		formInstruction1.setHorizontalAlignment(SwingConstants.CENTER);
		formInstruction2.setHorizontalAlignment(SwingConstants.CENTER);
		formInstruction3.setHorizontalAlignment(SwingConstants.CENTER);
		yourNameLabel.setHorizontalAlignment(SwingConstants.RIGHT);
		address1Label.setHorizontalAlignment(SwingConstants.RIGHT);
		address2Label.setHorizontalAlignment(SwingConstants.RIGHT);
		cityLabel.setHorizontalAlignment(SwingConstants.RIGHT);
		messagePanel.setLayout(expaningVerticalFlowLayout);
		address1Panel.setLayout(paymentFormFlowLayout);
		address2Panel.setLayout(paymentFormFlowLayout);
		cityPanel.setLayout(paymentFormFlowLayout);
		paymentFormFlowLayout.setAlignment(FlowLayout.RIGHT);
		paymentFormFlowLayout.setHgap(15);
		yourNameField.setColumns(40);
		address1Field.setColumns(40);
		address2Field.setColumns(40);
		cityField.setColumns(40);
		messagePanel.add(formInstruction1, null);
		messagePanel.add(formInstruction2, null);
		formPanel.add(formInstruction3, null);
		formPanel.add(namePanel, null);
		formPanel.add(address1Panel, null);
		formPanel.add(address2Panel, null);
		formPanel.add(cityPanel, null);
		if (textDirection.isLeftToRight()) {
			namePanel.add(yourNameLabel, null);
			namePanel.add(yourNameField, null);
			address1Panel.add(address1Label, null);
			address1Panel.add(address1Field, null);
			address2Panel.add(address2Label, null);
			address2Panel.add(address2Field, null);
			cityPanel.add(cityLabel, null);
			cityPanel.add(cityField, null);
		} else {
			namePanel.add(yourNameField, null);
			namePanel.add(yourNameLabel, null);
			address1Panel.add(address1Field, null);
			address1Panel.add(address1Label, null);
			address2Panel.add(address2Field, null);
			address2Panel.add(address2Label, null);
			cityPanel.add(cityField, null);
			cityPanel.add(cityLabel, null);
			formInstruction1.setComponentOrientation(ComponentOrientation.RIGHT_TO_LEFT);
			formInstruction2.setComponentOrientation(ComponentOrientation.RIGHT_TO_LEFT);
			formInstruction3.setComponentOrientation(ComponentOrientation.RIGHT_TO_LEFT);
			yourNameLabel.setComponentOrientation(ComponentOrientation.RIGHT_TO_LEFT);
			address1Label.setComponentOrientation(ComponentOrientation.RIGHT_TO_LEFT);
			address2Label.setComponentOrientation(ComponentOrientation.RIGHT_TO_LEFT);
			cityLabel.setComponentOrientation(ComponentOrientation.RIGHT_TO_LEFT);
		}

		submitButtonPanel.add(submitButton, null);

		/**
		 * Layout stopCard
		 */
		pinLabel.setBorder(null);
		pinLabel.setFont(new Font("Dialog", 0, bigTypesize));
		pinLabel.setHorizontalAlignment(SwingConstants.CENTER);
		pinTextLabel.setBackground(Color.green);
		pinTextLabel.setHorizontalAlignment(SwingConstants.CENTER);
		stopTheSessionLabel.setBackground(Color.white);
		stopTheSessionLabel.setHorizontalAlignment(SwingConstants.CENTER);
		stopCardGridLayout.setRows(3);
		stopCardGridLayout.setColumns(1);
		stopCard.add(stopTheSessionLabel, null);
		stopCard.add(pinTextLabel, null);
		stopCard.add(pinLabel, null);
		stopCard.setBackground(Color.green);
		stopCard.setLayout(stopCardGridLayout);
		/**
		 * Establish listeners
		 */
		questionnaireContinueButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				questionnaireContinueButton_actionPerformed(e);
			}
		});
		tutorialButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				tutorialButton_actionPerformed(e);
			}
		});
		slider1
				.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
					public void propertyChange(PropertyChangeEvent e) {
						slider1_propertyChange(e);
					}
				});
		saveButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				saveButton_actionPerformed(e);
			}
		});
		editButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				editButton_actionPerformed(e);
			}
		});
		skipButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				skipButton_actionPerformed(e);
			}
		});
		reviseComboBox.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				redoTheSelectedStimulus(e);
			}
		});
		submitButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				submitButton_actionPerformed(e);
			}
		});

		/**
		 * Start processes
		 */
		translate(currentLocale);
		editingListOfDoneStimuli = false;
		presentingTutorial = false;
		tutorialPanel.setVisible(false);
		numberOfSkippedStimuli = 0;
		numberOfEditedStimuli = 0;
		// Select desired start point.
		if (numberOfQuestions > 0) {
			appletCardLayout.show(this.getContentPane(), "questionnaireCard");
			questionIndex = 0;
			presentQuestion();
		} else if (tutorialIncluded) {
			giveTutorial();
		} else {
			beginRating();
		}
	}

	void translate(Locale place) {
		String nameOfSet;
		if (forceStimulusSet > 0) {
			// Forcing a stimulus set for testing.
			nameOfSet = "surveyor2.Words_" + Integer.toString(forceStimulusSet);
		} else {
			// Input a stimuli set randomly.
			int stimuliSet = randomizer.nextInt(numberOfStimuliSets) + 1;
			System.out.println(stimuliSet);
			nameOfSet = "surveyor2.Words_" + Integer.toString(stimuliSet);
		}
		StimuliSet = ResourceBundle.getBundle(nameOfSet, place);
		readStimuli();
		// Set the buttons' texts and the label for stopping.
		questionnaireInstruction.setText(InterfaceTexts
				.getString("questionnaireInstruction"));
		questionnaireContinueButton.setText(InterfaceTexts
				.getString("questionnaireContinueButton"));
		tutorialButton.setText(InterfaceTexts.getString("tutorialButton"));
		saveButton.setText(InterfaceTexts.getString("saveButton"));
		skipButton.setText(InterfaceTexts.getString("skipButton"));
		editButton.setText(InterfaceTexts.getString("correctButton"));
		stopTheSessionLabel.setText(InterfaceTexts.getString("stopCardText"));
		// Get the adjective arrays.
		String dimNumeral, adjNumeral;
		String posName = "Pos_";
		String negName = "Neg_";
		for (int i = 0; i < NUMBER_OF_SCALES; i++) {
			for (int j = 0; j < NUMBER_OF_ADJECTIVES; j++) {
				dimNumeral = (new Integer(i + 1)).toString();
				adjNumeral = (new Integer(j + 1)).toString();
				positiveModifiers[i][j] = InterfaceTexts.getString(posName
						+ dimNumeral + "_" + adjNumeral);
				negativeModifiers[i][j] = InterfaceTexts.getString(negName
						+ dimNumeral + "_" + adjNumeral);
			}
		}
		// Set the adverbs.
		infiniteL.setText(InterfaceTexts.getString("infinitely"));
		extremeL.setText(InterfaceTexts.getString("extremely"));
		quiteL.setText(InterfaceTexts.getString("quite"));
		slightL.setText(InterfaceTexts.getString("slightly"));
		neutral.setText(InterfaceTexts.getString("neutral"));
		slightR.setText(InterfaceTexts.getString("slightly"));
		quiteR.setText(InterfaceTexts.getString("quite"));
		extremeR.setText(InterfaceTexts.getString("extremely"));
		infiniteR.setText(InterfaceTexts.getString("infinitely"));

		slider1.setToolTipText(InterfaceTexts.getString("sliderToolTip"));
		// Set up personal information form.
		formInstruction1.setText(InterfaceTexts.getString("formInstruction1"));
		formInstruction2.setText(InterfaceTexts.getString("formInstruction2"));
		formInstruction3.setText(InterfaceTexts.getString("formInstruction3"));
		yourNameLabel.setText(InterfaceTexts.getString("yourName"));
		address1Label.setText(InterfaceTexts.getString("uniqueIdentifier"));
		address2Label.setText(InterfaceTexts.getString("address"));
		cityLabel.setText(InterfaceTexts.getString("city"));
		submitButton.setText(InterfaceTexts.getString("submit"));
	} // End translate.

	void readStimuli() {
		// Read the project name and stimuli set.
		projectIdentification = StimuliSet.getString("projectIdentification");
		stimuliSetIdentification = StimuliSet
				.getString("stimuliSetIdentification");
		nameOfArchive = projectIdentification + stimuliSetIdentification;
		// Get the questions and stimuli.
		String[] Stimulus = (String[]) StimuliSet.getStringArray("textArray");
		int numberOfInputLines = Stimulus.length;
		// Get background questions at front of stimuli list.
		querySet = new Vector();
		numberOfQuestions = 0;
		while (Stimulus[numberOfQuestions].startsWith(TEXT_DELIMITER)) {
			// First get the INDIGENOUS-LANGUAGE VERSION.
			String remainingText = Stimulus[numberOfQuestions];
			BackgroundQuestion question = new BackgroundQuestion();
			querySet.addElement(question);
			// Get rid of the first delimiter, and store text up to next
			// delimiter.
			remainingText = remainingText.substring(remainingText
					.indexOf(TEXT_DELIMITER) + 1);
			question.stub = remainingText.substring(0, remainingText
					.indexOf(TEXT_DELIMITER));
			// Parse the options.
			int choiceIndex = 0;
			do {
				// Get rid of the text at front, then store text up to next
				// delimiter.
				remainingText = remainingText.substring(remainingText
						.indexOf(TEXT_DELIMITER) + 1);
				question.option[choiceIndex++] = remainingText.substring(0,
						remainingText.indexOf(TEXT_DELIMITER));
			} while (remainingText.indexOf(TEXT_DELIMITER) != remainingText
					.lastIndexOf(TEXT_DELIMITER)); // Until only last delimiter
													// remains.
			// Now get the ENGLISH-LANGUAGE VERSION.
			remainingText = Stimulus[numberOfQuestions + 1];
			// Get rid of the first delimiter, and store text up to next
			// delimiter.
			remainingText = remainingText.substring(remainingText
					.indexOf(TEXT_DELIMITER) + 1);
			question.EnglishStub = remainingText.substring(0, remainingText
					.indexOf(TEXT_DELIMITER));
			// Parse the options.
			choiceIndex = 0;
			do {
				// Get rid of the text at front, then store text up to next
				// delimiter.
				remainingText = remainingText.substring(remainingText
						.indexOf(TEXT_DELIMITER) + 1);
				question.EnglishOption[choiceIndex++] = remainingText
						.substring(0, remainingText.indexOf(TEXT_DELIMITER));
			} while (remainingText.indexOf(TEXT_DELIMITER) != remainingText
					.lastIndexOf(TEXT_DELIMITER)); // Until only last delimiter
													// remains.
			numberOfQuestions = numberOfQuestions + 2;
		}
		// Translate rating stimuli to dataSet, an array of DataLine.
		for (int i = 0; i < MAX_SCALES; i = i + 1) {
			INITIAL_RATINGS[i] = NO_DATA;
		}
		numberOfStimuli = (numberOfInputLines - numberOfQuestions) / 2;
		dataSet = new DataLine[numberOfStimuli];
		for (int i = 0; i < 2 * numberOfStimuli; i = i + 2) {
			// Read by pairs: indigenous stimulus, U.S.A. keyword.
			dataSet[i / 2] = new DataLine(Stimulus[numberOfQuestions + i],
					Stimulus[numberOfQuestions + i + 1], INITIAL_RATINGS);
		}
		stimuliDone = 0;
		numberOfQuestions = numberOfQuestions / 2; // Number of
													// indigenous-English pairs.
	} // End readStimuli.

	void presentQuestion() {
		currentQuestion = (BackgroundQuestion) querySet
				.elementAt(questionIndex);
		questionStub.setText(currentQuestion.stub);
		for (int i = 0; i < BackgroundQuestion.MAX_OPTIONS; i++) {
			option[i].setVisible(false);
		}
		option[BackgroundQuestion.MAX_OPTIONS - 1]
				.setText(BackgroundQuestion.DUMMY_OPTION);
		option[BackgroundQuestion.MAX_OPTIONS - 1].setVisible(false);
		option[BackgroundQuestion.MAX_OPTIONS - 1].setSelected(true);
		int optionIndex = -1;
		while (!currentQuestion.option[++optionIndex].equalsIgnoreCase("")) {
			option[optionIndex].setText(currentQuestion.option[optionIndex]);
			option[optionIndex].setVisible(true);
		}
	} // End presentQuestion.

	void questionnaireContinueButton_actionPerformed(ActionEvent e) {
		// Get the answer.
		currentQuestion.answer = 0;
		do {
		} while (optionsGroup.getSelection() != option[currentQuestion.answer++]
				.getModel());
		if (currentQuestion.answer == BackgroundQuestion.MAX_OPTIONS) { 
			// Hidden option is default selection so that all visible options
			// start off unchosen.
			return;
		}
		// The above while-loop has set answer for currentQuestion to user's
		// choice.
		// Present next question, or go on to ratings.
		if (++questionIndex < numberOfQuestions) {
			presentQuestion();
		} else if (tutorialIncluded) {
			giveTutorial();
		} else {
			beginRating();
		}
	} // End questionnaireContinueButton_actionPerformed.

	void beginRating() {
		editingListOfDoneStimuli = true;
		reviseComboBox.removeAllItems();
		reviseComboBox.addItem(InterfaceTexts.getString("EditingInstruction"));
		editingListOfDoneStimuli = false;
		tempTime = System.currentTimeMillis();
		ratingsStartTime = System.currentTimeMillis(); // Initialization.
		currentStimulus = -1;
		numberOfSkippedStimuli = 0;
		numberOfEditedStimuli = 0;
		changeStimulus();
		changeDimension();
		appletCardLayout.show(this.getContentPane(), "ratingCard");
	} // End beginRating.

	void changeStimulus() {
		String testConcept;
		if (doneWithAllStimuli()) return;
		if (randomStimuliOrder & (stimuliDone + 10 < (numberOfStimuli))) {
			// Random draws for most stimuli.
			do { // Find an unrated stimulus.
				currentStimulus = randomizer.nextInt(numberOfStimuli);
				testConcept = dataSet[currentStimulus].word;
			} while (dataSet[currentStimulus].itemDone);
		} else {
			// Systematic draws for last 10 stimuli; or if forceStimulusSet
			// parameter is negative.
			currentStimulus = -1;
			while (dataSet[++currentStimulus].itemDone) {
			}
			;
			testConcept = dataSet[currentStimulus].word;
		}
		if (testConcept.indexOf(TEXT_DELIMITER) > 0) {
			Stimulus1.setText(testConcept.substring(0, testConcept
					.indexOf(TEXT_DELIMITER)));
			Stimulus2.setText(testConcept.substring(testConcept
					.indexOf(TEXT_DELIMITER) + 1));
		} else {
			Stimulus1.setText("");
			Stimulus2.setText(testConcept);
		}

		// Report number of stimuli still to go.
		String message;
		if (stimuliDone <= startCountdownAt) {
			message = " ";
		} else {
			message = InterfaceTexts.getString("labelForNumberUndone");
			message = message + numberFormater.format(numberOfStimuli - stimuliDone);
		}
		progressLabel.setText(message);
	} // End changeStimulus.

	void changeDimension() {
		if (presentingTutorial) {
			// currentDimension = value assigned in
			// tutorialButton_actionPerformed.
			reflectedScale = false;
		} else {
			if (doneWithThisStimulus()) {
				// All dimensions rated.
				currentDimension = -1;
				return;
			} else {
				// Find an unrated dimension for the current stimulus.
				do {
					currentDimension = randomizer.nextInt(NUMBER_OF_SCALES);
				} while (dataSet[currentStimulus].dimensionDone[currentDimension]);
			}
			reflectedScale = (randomizer.nextInt() > 0);
		}
		if (reflectedScale) {
			slider1.setReflectedScale(true);
			leftAdjective0.setText(positiveModifiers[currentDimension][0]);
			leftAdjective1.setText(positiveModifiers[currentDimension][1]);
			leftAdjective2.setText(positiveModifiers[currentDimension][2]);
			leftAdjective3.setText(positiveModifiers[currentDimension][3]);
			leftAdjective4.setText(positiveModifiers[currentDimension][4]);
			rightAdjective0.setText(negativeModifiers[currentDimension][0]);
			rightAdjective1.setText(negativeModifiers[currentDimension][1]);
			rightAdjective2.setText(negativeModifiers[currentDimension][2]);
			rightAdjective3.setText(negativeModifiers[currentDimension][3]);
			rightAdjective4.setText(negativeModifiers[currentDimension][4]);
		} else {
			slider1.setReflectedScale(false);
			leftAdjective0.setText(negativeModifiers[currentDimension][0]);
			leftAdjective1.setText(negativeModifiers[currentDimension][1]);
			leftAdjective2.setText(negativeModifiers[currentDimension][2]);
			leftAdjective3.setText(negativeModifiers[currentDimension][3]);
			leftAdjective4.setText(negativeModifiers[currentDimension][4]);
			rightAdjective0.setText(positiveModifiers[currentDimension][0]);
			rightAdjective1.setText(positiveModifiers[currentDimension][1]);
			rightAdjective2.setText(positiveModifiers[currentDimension][2]);
			rightAdjective3.setText(positiveModifiers[currentDimension][3]);
			rightAdjective4.setText(positiveModifiers[currentDimension][4]);
		}
	} // End changeDimension.

	void saveButton_actionPerformed(ActionEvent e) {
		// Record the rating and go to next dimension or stimulus or step.
		if (!slider1.isSliderMoved()) return; // Movement of slider required.
		if (presentingTutorial) {
			slider1.snapToOrigin();
			tutorialButton_actionPerformed(dummyEvent);
			return;
		}
		dataSet[currentStimulus].profile[currentDimension] = slider1
				.getScaleValue();
		dataSet[currentStimulus].dimensionDone[currentDimension] = true;
		slider1.snapToOrigin();
		if (doneWithThisStimulus()) {
			recordCurrentItemIsDone();
			if (doneWithAllStimuli()) {
				concludeRatings();
				return;
			} else {
				changeStimulus();
			}
		}
		changeDimension();
	} // End saveButton_actionPerformed.

	void editButton_actionPerformed(ActionEvent e) {
		if (!presentingTutorial) {
			if (editButton.getText().equalsIgnoreCase(
					InterfaceTexts.getString("correctButton"))) {
				progressLabel.setVisible(false);
				skipButton.setVisible(false);
				reviseComboBox.setVisible(true);
				editButton.setText(InterfaceTexts.getString("noCorrectButton"));
			} else { // User clicked No-change.
				if (doneWithAllStimuli()) { // Conclude session.
					progressLabel.setVisible(false);
					editButton.setVisible(false);
					reviseComboBox.setVisible(false);
					concludeSession();
				} else { // Continue with ratings.
					progressLabel.setVisible(true);
					skipButton.setVisible(true);
					editButton.setText(InterfaceTexts
							.getString("correctButton"));
					reviseComboBox.setVisible(false);
				}
			}
		} else { // In tutorial.
			if (currentTutorialPage != 9) { return; } 
			// Tutorial page 9 asks user to click Change button.
			tutorialButton_actionPerformed(dummyEvent);
		}
	} // End editButton_actionPerformed.

	void skipButton_actionPerformed(ActionEvent e) {
		int decisionToSkip;
		if ((presentingTutorial) & (currentTutorialPage != 11)) { return; } 
		// Tutorial page 11 asks user to click Skip button.
		if (!debuggingSkip) {
			decisionToSkip = JOptionPane.showOptionDialog(
					this.getContentPane(), // Frame
					InterfaceTexts.getString("areYouSureMessage"), // Text
					"", // Box title.
					JOptionPane.OK_CANCEL_OPTION,
					JOptionPane.PLAIN_MESSAGE,
					null, // No icon.
					new String[] { // Button labels.
					InterfaceTexts.getString("confirmSkipButton"),
							InterfaceTexts.getString("cancelSkipButton") },
					InterfaceTexts.getString("cancelSkipButton") // Default button.
					);
		} else {
			decisionToSkip = JOptionPane.OK_OPTION;
		}
		if (presentingTutorial) {
			tutorialButton_actionPerformed(dummyEvent);
			return;
		}
		if (decisionToSkip == JOptionPane.OK_OPTION) { // Skip this stimulus.
			numberOfSkippedStimuli = numberOfSkippedStimuli + 1;
			// Punish skipping with a pause.
			Date start = new Date();
			Date stop = new Date(start.getTime() + PAUSE_TIME);
			while ((new Date()).before(stop)) {
			}
			; // Pause by looping.
			// Skip the current stimulus.
			for (int i = 0; i < NUMBER_OF_SCALES; i++) {
				dataSet[currentStimulus].profile[i] = ABORTED_DATA; 
				// Remove any ratings that were done.
				dataSet[currentStimulus].dimensionDone[i] = true;
			}
			recordCurrentItemIsDone();
			if (doneWithAllStimuli()) {
				concludeRatings();
				return;
			}
			changeStimulus();
			changeDimension();
		}
	} // End skipButton_actionPerformed.

	void slider1_propertyChange(PropertyChangeEvent e) {
		if (!presentingTutorial) {
			if (!usingSaveButton) {
				saveButton_actionPerformed(dummyEvent);
			}
		} else { // Tutorial actions.
			if (!saveButtonPanel.isVisible()) {
				slider1.snapToOrigin();
				tutorialButton_actionPerformed(dummyEvent);
			}
		}
	} // End slider1_propertyChange.

	void redoTheSelectedStimulus(ActionEvent e) {
		if (presentingTutorial) { return; }
		if (((String) reviseComboBox.getSelectedItem())
				.equalsIgnoreCase(InterfaceTexts
						.getString("EditingInstruction"))) { return; } 
						// No item selected.
		if (editingListOfDoneStimuli) { return; } // Ignore item event from
													// changing the list.
		// Find the item in the dataset.
		String stimulusBeingChanged = (String) reviseComboBox.getSelectedItem();
		currentStimulus = -1;
		while (!dataSet[++currentStimulus].word
				.equalsIgnoreCase(stimulusBeingChanged)) {
		}
		;
		// Undo the item.
		for (int i = 0; i < NUMBER_OF_SCALES; i++) {
			dataSet[currentStimulus].profile[i] = (new Double(NO_DATA))
					.doubleValue();
			dataSet[currentStimulus].dimensionDone[i] = false;
		}
		dataSet[currentStimulus].itemDone = false;
		editingListOfDoneStimuli = true;
		reviseComboBox.removeItem(stimulusBeingChanged);
		editingListOfDoneStimuli = false;
		stimuliDone = stimuliDone - 1;
		numberOfEditedStimuli = numberOfEditedStimuli + 1;
		// Re-rate the item.
		if (stimulusBeingChanged.indexOf(TEXT_DELIMITER) > 0) {
			Stimulus1.setText(stimulusBeingChanged.substring(0,
					stimulusBeingChanged.indexOf(TEXT_DELIMITER)));
			Stimulus2
					.setText(stimulusBeingChanged
							.substring(stimulusBeingChanged
									.indexOf(TEXT_DELIMITER) + 1));
		} else {
			Stimulus1.setText("");
			Stimulus2.setText(stimulusBeingChanged);
		}
		if (doneWithAllStimuli()) {
			tutorialPanel.setVisible(false);
		}
		if (usingSaveButton) {
			saveButton.setVisible(true);
		}
		progressLabel.setVisible(true);
		skipButton.setVisible(true);
		editButton.setText(InterfaceTexts.getString("correctButton"));
		reviseComboBox.setVisible(false);
		editingListOfDoneStimuli = false;
		changeDimension();
	} // End redoTheSelectedStimulus.

	void submitButton_actionPerformed(ActionEvent e) {
		respondentInfo = yourNameField.getText() + COMMA_SPACE;
		respondentInfo = respondentInfo + address1Field.getText() + COMMA_SPACE;
		respondentInfo = respondentInfo + address2Field.getText() + COMMA_SPACE;
		respondentInfo = respondentInfo + cityField.getText();
		deliverData();
	} // End submitButton_actionPerformed.

	boolean doneWithThisStimulus() {
		// Check if all dimensions have been rated.
		boolean allDimensionsDone = true;
		for (int i = 0; i < NUMBER_OF_SCALES; i++) {
			allDimensionsDone = allDimensionsDone
					& dataSet[currentStimulus].dimensionDone[i];
		}
		return allDimensionsDone;
	} // End doneWithThisStimulus.

	boolean doneWithAllStimuli() {
		return (stimuliDone >= numberOfStimuli);
	} // End doneWithAllStimuli.

	void concludeRatings() {
		concludingRatings = true;
		// Give user a last chance to correct ratings.
		progressLabel.setText("");
		Stimulus1.setText("");
		Stimulus2.setText("");
		tutorialPanel.setVisible(true);
		tutorialButton.setVisible(false);
		skipButton.setVisible(false);
		saveButton.setVisible(false);
		editButton.setVisible(true);
		String stringName = "concludingQuery";
		for (int i = 0; i < NUMBER_OF_TUTORIAL_LINES; i++) {
			tutorialLine[i].setText(InterfaceTexts.getString(stringName
					+ (new Integer(i + 1)).toString()));
		}
		// Rename edit button from "change" to "no change" and show
		// reviseComboBox.
		progressLabel.setVisible(false);
		skipButton.setVisible(false);
		reviseComboBox.setVisible(true);
		editButton.setText(InterfaceTexts.getString("noCorrectButton"));
	} // End concludeRatings.

	void concludeSession() {
		// Generate respondent's PIN.
		ratingsStopTime = System.currentTimeMillis();
		PIN = (ratingsStopTime - baseTime);
		PINstring = new Long(PIN).toString();

		respondentInfo = "";
		if (acquiringPersonalData) {
			// Present the name-address form.
			appletCardLayout.show(this.getContentPane(), "paymentCard");
		} else {
			deliverData();
		}
	} // End concludeSession.

	void deliverData() {
		URL url;
		URLConnection urlConn;
		DataOutputStream printout;
		BufferedReader input;
		String outputData, backtalk, str;
		backtalk = "";
		if ((!acquiringPersonalData) | (anonymous)) {
			respondentInfo = "Anonymous";
		}

		// Construct the first line of the dataset.
		// IU's Transform archiving program will make the first item:
		// TimeSet [the number of seconds since Jan 1, 1970]
		// Then comes an identifier of the project and stimulus set number.
		// Next is the respondent info that was gathered (or "anonymous").
		// Then comes the number of skipped stimuli, followed by the number of
		// edited stimuli.
		outputData = "StimulusSet," + QUOTE + nameOfArchive + QUOTE
				+ COMMA_SPACE + "RespondentInfo," + QUOTE + respondentInfo
				+ QUOTE + COMMA_SPACE + "NumberSkipped,"
				+ (new Integer(numberOfSkippedStimuli)).toString()
				+ COMMA_SPACE + "NumberEdited,"
				+ (new Integer(numberOfEditedStimuli)).toString() + COMMA_SPACE;
		// The final item on the first line is the number of minutes respondent
		// took for ratings, not including background questions or tutorial.
		timeIncrement = ratingsStopTime - ratingsStartTime;
		ratingTime = timeIncrement / 60000;
		outputData = outputData + "MinutesForRatings,"
				+ (new Long(ratingTime)).toString() + NEW_LINE;
		// Store answers to background questions.
		questionIndex = -1;
		while (++questionIndex < numberOfQuestions) {
			// Each line contains number of option chosen starting at zero,
			// comma, text of chosen option.
			BackgroundQuestion anItem = (BackgroundQuestion) querySet
					.elementAt(questionIndex);
			outputData = outputData + QUOTE
					+ anItem.EnglishOption[anItem.answer - 1] + QUOTE
					+ COMMA_SPACE;
			outputData = outputData + (new Integer(anItem.answer)).toString()
					+ NEW_LINE;
		}
		// Store stimuli and EPA ratings on a line each.
		for (int i = 0; i < numberOfStimuli; i++) {
			outputData = outputData + QUOTE + dataSet[i].keyword + QUOTE; // Output
			// shows
			// U.S.A.
			// keyword.
			for (int j = 0; j < NUMBER_OF_SCALES; j++) {
				outputData = outputData + COMMA_SPACE
						+ (new Double(dataSet[i].profile[j])).toString();
			}
			outputData = outputData + NEW_LINE;
		}
		if (internetSave) {
			/*
			 * POST outputData to Transform on IU Web server. Routine from URL:
			 * http://www.javaworld.com/javaworld/javatips/jw-javatip34.html
			 */
			try {
				// URL of CGI-Bin script assuming that the applet directory has
				// name: projectIdentification.
				url = new URL(
						"http://www.indiana.edu/~socpsy/surveyor2/transform.cgi?socpsy/www/surveyor2/"
								+ projectIdentification + "/archiver.tpl");
				// URL connection channel.
				urlConn = url.openConnection();
				// Let the run-time system (RTS) know that we want input.
				urlConn.setDoInput(true);
				// Let the RTS know that we want to do output.
				urlConn.setDoOutput(true);
				// No caching, we want the real thing.
				urlConn.setUseCaches(false);
				// Specify the content type.
				urlConn.setRequestProperty("Content-Type",
						"application/x-www-form-urlencoded");
				// Send POST output.
				printout = new DataOutputStream(urlConn.getOutputStream());
				String code = "UTF-8";
				String content = "project="
						+ URLEncoder.encode(projectIdentification, code)
						+ "&stimulusSet="
						+ URLEncoder.encode(stimuliSetIdentification, code)
						+ "&emailAddress="
						+ URLEncoder.encode(emailAddress, code)
						+ "&respondentInfo="
						+ URLEncoder.encode(respondentInfo, code) + "&pin="
						+ URLEncoder.encode(PINstring, code) + "&data="
						+ URLEncoder.encode(outputData, code);
				printout.writeBytes(content);
				printout.flush();
				printout.close();
				// Get response data.
				input = new BufferedReader(new InputStreamReader(urlConn
						.getInputStream()));
				while (null != (str = input.readLine())) {
					backtalk = backtalk + str;
				}
				input.close();
			} catch (MalformedURLException me) {
				System.err.println("MalformedURLException: " + me);
			} catch (IOException ioe) {
				System.err.println("IOException: debug=" + ioe);
			}
			/*
			 * End of borrowed routine to POST data to Transform.
			 */
		} else {
			/*
			 * Save the data to directory X:\projectdata on the computer running
			 * the applet.
			 * 
			 * This requires:
			 * first, that the applet has been called from an
			 * HTML file and jar file on the same computer, in directory
			 * C:\Surveyor; 
			 * second, that a data subdirectory is included - i.e., C:\Surveyor\Data
			 * third, that file 
			 * C:\Program Files\Java\jre6\lib\security\java.policy 
			 * has the following appended to its bottom:
			 * 
			 * permission java.io.FilePermission "C:/Surveyor/Data/-", "write";
			 * 
			 * fourth, that the jar file in C:\Surveyor contains all
			 * required Messages files and Words_i class files; and, 
			 * fifth, that the HTML file includes the parameter declaration
			 *  <PARAM NAME=InternetSave VALUE=false>
			 */
			String filename = "data" + stimuliSetIdentification;
			String timeStamp = "TimeStamp, " + PINstring + ", ";
			try {
				BufferedWriter out = new BufferedWriter(new FileWriter(
						DATA_DIRECTORY + filename + ".dat", true)); 
						// true means append
				out.write(timeStamp + outputData + NEW_LINE + NEW_LINE);
				out.close();
			} catch (IOException e) {
				System.out.println("File error");
			}
			backtalk = "OKAY";
			successURL = null;
		}
		// Give success or failure message to respondent.
		System.err.println(backtalk);
		if (backtalk.indexOf("OKAY") > -1) {
			// Data stored successfully.
			successURL = null;
			if (!successURLstring.equalsIgnoreCase("")) {
				// See
				// http://java.sun.com/docs/books/tutorial/deployment/applet/browser.html
				try {
					successURL = new URL(successURLstring);
				} catch (MalformedURLException e) {
					System.out.println("Success URL is malformed.");
				}
			}
			if (successURL != null) {
				// End with a success web page.
				getAppletContext().showDocument(successURL, "_self");
			} else {
				// Present final message, including PIN.
				Stimulus1.setText(InterfaceTexts.getString("pinText"));
				Stimulus2.setText(numberFormater.format(PIN));
				tutorialPanel.setVisible(true);
				tutorialButton.setVisible(false);
				slider1.setVisible(false);
				leftAdjectivePanel.setVisible(false);
				rightAdjectivePanel.setVisible(false);
				adverbPanel.setVisible(false);
				saveButtonPanel.setVisible(false);
				progressPanel.setVisible(false);
				editButton.setVisible(false);
				String stringName = "thankYou";
				for (int i = 0; i < NUMBER_OF_TUTORIAL_LINES; i++) {
					tutorialLine[i].setText(InterfaceTexts.getString(stringName
							+ (new Integer(i + 1)).toString()));
				}
				appletCardLayout.show(this.getContentPane(), "ratingCard");
			}
		} else {
			// Data storage failed. Give the PIN on the failure card.
			pinTextLabel.setText(InterfaceTexts.getString("pinText"));
			pinLabel.setText(PINstring);
			appletCardLayout.show(this.getContentPane(), "stopCard");
		}
	} // End deliverData.

	void giveTutorial() {
		presentingTutorial = true;
		appletCardLayout.show(this.getContentPane(), "ratingCard");
		tutorialPanel.setVisible(true);
		tutorialButton.setVisible(true);
		stimulusPanel.setVisible(false);
		slider1.setVisible(false);
		leftAdjective0.setForeground(Color.white);
		leftAdjective1.setForeground(Color.white);
		leftAdjective2.setForeground(Color.white);
		leftAdjective3.setForeground(Color.white);
		leftAdjective4.setForeground(Color.white);
		rightAdjective0.setForeground(Color.white);
		rightAdjective1.setForeground(Color.white);
		rightAdjective2.setForeground(Color.white);
		rightAdjective3.setForeground(Color.white);
		rightAdjective4.setForeground(Color.white);

		adverbPanel.setVisible(false);
		saveButtonPanel.setVisible(false);
		progressPanel.setVisible(false);
		currentTutorialPage = 1;
		String stringName = "Tutorial_"
				+ (new Integer(currentTutorialPage)).toString() + "_";
		for (int i = 0; i < NUMBER_OF_TUTORIAL_LINES; i++) {
			tutorialLine[i].setText(InterfaceTexts.getString(stringName
					+ (new Integer(i + 1)).toString()));
		}
		beginRating();
	} // End giveTutorial.

	void tutorialButton_actionPerformed(ActionEvent e) {
		switch (++currentTutorialPage) {
		case 2:
			stimulusPanel.setVisible(true);
			Stimulus2.setText(InterfaceTexts.getString("TutorialStimulus1"));
			break;
		case 3:
			slider1.setVisible(true);
			tutorialButton.setVisible(false);
			break;
		case 4:
			tutorialButton.setVisible(true);
			adverbPanel.setVisible(true);
			break;
		case 5:
			leftAdjective0.setForeground(Color.black);
			leftAdjective1.setForeground(Color.black);
			leftAdjective2.setForeground(Color.black);
			leftAdjective3.setForeground(Color.black);
			leftAdjective4.setForeground(Color.black);
			rightAdjective0.setForeground(Color.black);
			rightAdjective1.setForeground(Color.black);
			rightAdjective2.setForeground(Color.black);
			rightAdjective3.setForeground(Color.black);
			rightAdjective4.setForeground(Color.black);
			currentDimension = 0;
			changeDimension();
			break;
		case 6:
			currentDimension = 1;
			changeDimension();
			break;
		case 7:
			currentDimension = 2;
			changeDimension();
			tutorialButton.setVisible(false);
			if (usingSaveButton) {
				saveButtonPanel.setVisible(true);
			}
			break;
		case 8:
			Stimulus2.setText(InterfaceTexts.getString("TutorialStimulus2"));
			break;
		case 9:
			progressPanel.setVisible(true);
			break;
		case 10:
			tutorialButton.setVisible(true);
			Stimulus2.setText("");
			editButton.setText(InterfaceTexts.getString("noCorrectButton"));
			editingListOfDoneStimuli = true;
			reviseComboBox.addItem(InterfaceTexts
					.getString("EditingInstruction"));
			reviseComboBox.addItem(InterfaceTexts
					.getString("TutorialStimulus1"));
			reviseComboBox.addItem(InterfaceTexts
					.getString("TutorialStimulus2"));
			editingListOfDoneStimuli = false;
			reviseComboBox.setVisible(true);
			break;
		case 11:
			tutorialButton.setVisible(false);
			Stimulus2.setText(InterfaceTexts.getString("TutorialStimulus3"));
			editButton.setText(InterfaceTexts.getString("correctButton"));
			editingListOfDoneStimuli = true;
			reviseComboBox.removeAllItems();
			editingListOfDoneStimuli = false;
			reviseComboBox.setVisible(false);
			break;
		case 12:
			tutorialButton.setVisible(true);
			stimulusPanel.setVisible(false);
			slider1.setVisible(false);
			leftAdjectivePanel.setVisible(false);
			rightAdjectivePanel.setVisible(false);
			adverbPanel.setVisible(false);
			saveButtonPanel.setVisible(false);
			progressPanel.setVisible(false);
			tutorialButton.setText(InterfaceTexts
					.getString("questionnaireContinueButton"));

			break;
		default:
			presentingTutorial = false;
			numberOfSkippedStimuli = 0;
			numberOfEditedStimuli = 0;
			tutorialPanel.setVisible(false);
			stimulusPanel.setVisible(true);
			slider1.setVisible(true);
			leftAdjectivePanel.setVisible(true);
			rightAdjectivePanel.setVisible(true);
			adverbPanel.setVisible(true);
			saveButtonPanel.setVisible(true);
			progressPanel.setVisible(true);
			changeStimulus();
			changeDimension();
			return;
		}
		// Present the text for the current page.
		String stringName = "Tutorial_"
				+ (new Integer(currentTutorialPage)).toString() + "_";
		for (int i = 0; i < NUMBER_OF_TUTORIAL_LINES; i++) {
			tutorialLine[i].setText(InterfaceTexts.getString(stringName
					+ (new Integer(i + 1)).toString()));
		}
		// Delete tutorial's reference to Save button if not using one.
		if ((currentTutorialPage == 7) & (!usingSaveButton)) {
			tutorialLine[2].setText("");
		}
	}// / End tutorialButton_actionPerformed.

	void recordCurrentItemIsDone() {
		editingListOfDoneStimuli = true;
		reviseComboBox.addItem(dataSet[currentStimulus].word);
		editingListOfDoneStimuli = false;
		dataSet[currentStimulus].itemDone = true;
		stimuliDone = stimuliDone + 1;
	}

	public String getAppletInfo() {
		String description = " Surveyor 2 is the second-generation Magellan program for collecting EPA data and requires Java 2 on the user's machine.";
		return MADE_BY_HEISE + description;
	}

	public String[][] getParameterInfo() {
		String[][] pinfo = {
				{ "NumberOfStimuliSets", "int",
						"Number of alternative stimuli sets" },
				{ "BeginCountdownAt", "int",
						"How many stimuli before reporting number yet to do" },
				{ "UseSaveButton", "boolean",
						"Use a Save button to slow ratings" },
				{ "GiveTutorial", "boolean", "Give instructions for rating" },
				{ "ForceStimuliSet", "int", "Force set or randomize" },
				{ "Language", "String", "Unicode language" },
				{ "Country", "String", "Unicode country" },
				{ "Typesize", "int", "Adjective typesize in points" },
				{ "LineOfAdverbs", "boolean", "Single-line (true) or staggered" },
				{ "MeasuresPerStimulus", "int", "Number of rating scales." },
				{ "AcquirePersonalInfo", "boolean",
						"Include background questions" },
				{ "Anonymous", "boolean", "true = ID not in data" },
				{ "successURL", "String", "URL for new page at end" },
				{ "emailAddress", "String", "Place payment IDs are sent to" }, };
		return pinfo;
	}

}